public class QCodec extends java.lang.Object implements StringEncoder, StringDecoder
Similar to the Quoted-Printable content-transfer-encoding defined in RFC 1521 and designed to allow text containing mostly ASCII characters to be decipherable on an ASCII terminal without decoding.
RFC 1522 describes techniques to allow the encoding of non-ASCII text in various portions of a RFC 822 [2] message header, in a manner which is unlikely to confuse existing message handling software.
| 限定符和类型 | 字段和说明 |
|---|---|
protected static java.lang.String |
POSTFIX
Prefix
|
protected static java.lang.String |
PREFIX
Postfix
|
protected static char |
SEP
Separator.
|
| 构造器和说明 |
|---|
QCodec()
Default constructor.
|
QCodec(java.lang.String charset)
Constructor which allows for the selection of a default charset
|
| 限定符和类型 | 方法和说明 |
|---|---|
java.lang.Object |
decode(java.lang.Object pObject)
Decodes a quoted-printable object into its original form.
|
java.lang.String |
decode(java.lang.String pString)
Decodes a quoted-printable string into its original form.
|
protected java.lang.String |
decodeText(java.lang.String text)
Applies an RFC 1522 compliant decoding scheme to the given string of text.
|
protected byte[] |
doDecoding(byte[] bytes)
Decodes an array of bytes using the defined encoding scheme
|
protected byte[] |
doEncoding(byte[] bytes)
Encodes an array of bytes using the defined encoding scheme
|
java.lang.Object |
encode(java.lang.Object pObject)
Encodes an object into its quoted-printable form using the default charset.
|
java.lang.String |
encode(java.lang.String pString)
Encodes a string into its quoted-printable form using the default charset.
|
java.lang.String |
encode(java.lang.String pString,
java.lang.String charset)
Encodes a string into its quoted-printable form using the specified charset.
|
protected java.lang.String |
encodeText(java.lang.String text,
java.lang.String charset)
Applies an RFC 1522 compliant encoding scheme to the given string of text with the
given charset.
|
java.lang.String |
getDefaultCharset()
The default charset used for string decoding and encoding.
|
protected java.lang.String |
getEncoding()
Returns the codec name (referred to as encoding in the RFC 1522)
|
boolean |
isEncodeBlanks()
Tests if optional transformation of SPACE characters is to be used
|
void |
setEncodeBlanks(boolean b)
Defines whether optional transformation of SPACE characters is to be used
|
protected static final char SEP
protected static final java.lang.String POSTFIX
protected static final java.lang.String PREFIX
public QCodec()
public QCodec(java.lang.String charset)
charset - the default string charset to use.protected java.lang.String getEncoding()
protected byte[] doEncoding(byte[] bytes)
bytes - Data to be encodedprotected byte[] doDecoding(byte[] bytes)
throws DecoderException
bytes - Data to be decodedDecoderException - A decoder exception is thrown if a Decoder encounters a
failure condition during the decode process.public java.lang.String encode(java.lang.String pString,
java.lang.String charset)
throws EncoderException
pString - string to convert to quoted-printable formcharset - the charset for pStringEncoderException - thrown if a failure condition is encountered during the encoding process.public java.lang.String encode(java.lang.String pString)
throws EncoderException
encode 在接口中 StringEncoderpString - string to convert to quoted-printable formEncoderException - thrown if a failure condition is encountered during the encoding process.public java.lang.String decode(java.lang.String pString)
throws DecoderException
decode 在接口中 StringDecoderpString - quoted-printable string to convert into its original formDecoderException - A decoder exception is thrown if a failure condition is encountered during the decode process.public java.lang.Object encode(java.lang.Object pObject)
throws EncoderException
encode 在接口中 EncoderpObject - object to convert to quoted-printable formEncoderException - thrown if a failure condition is encountered during the encoding process.public java.lang.Object decode(java.lang.Object pObject)
throws DecoderException
decode 在接口中 DecoderpObject - quoted-printable object to convert into its original formDecoderException - Thrown if the argument is not a String. Thrown if a failure condition is
encountered during the decode process.public java.lang.String getDefaultCharset()
public boolean isEncodeBlanks()
true if SPACE characters are to be transformed, false otherwisepublic void setEncodeBlanks(boolean b)
b - true if SPACE characters are to be transformed, false otherwiseprotected java.lang.String encodeText(java.lang.String text,
java.lang.String charset)
throws EncoderException,
java.io.UnsupportedEncodingException
doEncoding(byte []) method of a concrete
class to perform the specific encoding.text - a string to encodecharset - a charset to be usedEncoderException - thrown if there is an error condition during the Encoding
process.java.io.UnsupportedEncodingException - thrown if charset is not supportedprotected java.lang.String decodeText(java.lang.String text)
throws DecoderException,
java.io.UnsupportedEncodingException
doEncoding(byte []) method of a concrete class to perform the specific decoding.text - a string to decodenull if the input is null.DecoderException - thrown if there is an error condition during the decoding
process.java.io.UnsupportedEncodingException - thrown if charset specified in the "encoded-word"
header is not supported